function UnCondMean=UnCondMeanVAR(PiRes,PhiRes,K,X,D,IncludeConstant,p)

N=size(X,1);
Niter=size(PiRes,1);

if IncludeConstant>0 
    D=[D ones(N,1)];
end
q=size(D,2);

UnCondMean=zeros(N,p,Niter);
if isempty(PhiRes)==1 % Constant on standard form
    for i=1:Niter
        Pi=(invvec(PiRes(i,:)',p*K+q))'; % Pi=[Pi_{1},...,Pi_{K} Phi]
        PiSum=zeros(p,p);
        for j=1:K
            PiSum=PiSum+Pi(:,1+(j-1)*p:j*p);
        end
        InvEyePiSum=inv(eye(p)-PiSum);
        Phi=(Pi(:,K*p+1:K*p+q));
        DPhi=D*Phi';
        for n=1:N
            UnCondMean(n,:,i)=InvEyePiSum*DPhi(n,:)';
        end
    end
else % Mean adjusted form
    for i=1:Niter
        Psi=invvec(PhiRes(i,:)',p);
        DPsi=D*Psi';
        for n=1:N
            UnCondMean(n,:,i)=DPsi(n,:)';
        end
    end
end